## bed-3.0.0.src.tar.xz

=== Makefile ===
ifeq ($(findstring Windows,$(OS)),Windows)
OpSys=Windows
endif
include config 
include prognames.mk
#MAKE=gmake
ifneq ($(CONFIG_PLUGIN),y)
ifneq ($(filter disass.plug,$(LINKIN) $(LINKINDYN)),)
DISASS_USE=y
endif
endif

REGEX_DIR=regex-0.13

ifneq ($(HAS_RE_SEARCH),y)
REGEX=src/regex.o
else
REGEX=
endif

ifeq ($(CONFIG_PROGMAN),y)
all:  has_appl has_file $(REGEX) $(CONFFILE) bed.menu 
else
all:  has_appl has_file $(REGEX) $(CONFFILE) 

endif

ifeq ($(BIOSDISK),y)
	$(MAKE) -C biosdisk 
endif
	$(MAKE) -C utils
	$(MAKE) -C plugins/examples  inlinklist plughelp
	$(MAKE) -C src
ifeq ($(CONFIG_PLUGIN),y)
	$(MAKE) -C plugins/examples  give
else
ifeq ($(DISASS_USE),y)
	$(MAKE) -C plugins/examples  disass-use
endif
endif


ifeq ($(CONFIG_XBED),y)
	$(MAKE) -C x11 $(XPROGRAM)
endif
	$(MAKE) -C doc

BEDBASE=$(PROGRAM)-$(VERSION)
LSMFILE=$(PROGRAM)-$(VERSION).lsm
SPECFILE=$(PROGRAM)-$(VERSION).spec

ROOTDIR:=$(abspath $(DESTDIR))

root:
	echo $(ROOTDIR)

ifeq ($(CONFIG_XBED),y)
XBEDMAN=$(ROOTDIR)$(MANDIR)/xbed.1 $(ROOTDIR)$(BINDIR)/xbed
endif
ifeq ($(CONFIG_PROGMAN),y)
MENUBED=$(ROOTDIR)$(MENUPATH)/bed
endif

ifeq ($(SYSTEM),Linux)
BINDIST=$(ROOTDIR)$(CONFDIR) $(ROOTDIR)$(CONFDIRLINK) $(ROOTDIR)$(BINDIR)/bed $(ROOTDIR)$(MANDIR)/bed.1.gz   $(MENUBED) $(XBEDMAN)
else
BINDIST=$(ROOTDIR)$(CONFDIR) $(ROOTDIR)$(CONFDIRLINK) $(ROOTDIR)$(BINDIR)/bed $(ROOTDIR)$(MANDIR)/bed.1   $(MENUBED) $(XBEDMAN)
endif


has_appl:has_appl.c
	$(TOBUILDCC)  $< -o $@

HAS_APPLICATIONS := $(shell ./has_appl)

has:
	echo $(HAS_APPLICATIONS)
ifneq ($(HAS_APPLICATIONS),)
BINDIST+=$(ROOTDIR)$(HAS_APPLICATIONS)/bed-binary-editor.desktop 
endif
ifeq ($(SYSTEM),FreeBSD)
BINDIST+=$(ROOTDIR)/usr/local/lib/nss_dns.so.1 
endif

#SORT=LC_ALL=C sort
install: installfiles
ifeq ($(DESTDIR),)
ifeq ($(HAS_FILE),y)
	@bash ./addmagic
endif
ifeq ($(CONFIG_PROGMAN),y)
	update-menus
endif
endif

installfiles: $(CONFFILE)  #$(LSMFILE)
ifeq ($(CYGWIN),yes)
	cd "c:\\"
endif
	-$(MKDIR) $(ROOTDIR)$(BINDIR)
	-rm   $(ROOTDIR)$(BINDIR)/$(EXEPROGRAM)
	$(CP) src/$(EXEPROGRAM) $(ROOTDIR)$(BINDIR)
	$(STRIP)  $(ROOTDIR)$(BINDIR)/$(EXEPROGRAM)
	-rm   $(ROOTDIR)$(CONFDIRLINK)
	-mv -f  $(ROOTDIR)$(CONFDIRLINK) $(ROOTDIR)$(CONFDIRLINK).bak
	-$(MKDIR) $(ROOTDIR)$(CONFDIR)
ifneq ($(CYGWIN),yes)
	$(MKDIR) `dirname $(ROOTDIR)$(CONFDIRLINK)`
	-mv  $(ROOTDIR)$(CONFDIR)/$(CONFFILE) $(ROOTDIR)$(CONFDIR)/~$(CONFFILE)
endif
	$(CP) $(CONFFILE) $(ROOTDIR)$(CONFDIR)
	chmod 0644 	$(ROOTDIR)$(CONFDIR)/$(CONFFILE)
	$(MAKE) -C doc install ROOTDIR=$(ROOTDIR)
	$(MAKE) -C misc install ROOTDIR=$(ROOTDIR)
ifeq ($(CONFIG_XBED),y)
	$(MAKE) -C x11 install ROOTDIR=$(ROOTDIR)
endif
ifeq ($(CONFIG_PLUGIN),y)
	$(MAKE) -C utils install ROOTDIR=$(ROOTDIR)
	$(MAKE) -C plugins install ROOTDIR=$(ROOTDIR)

else
ifeq ($(DISASS_USE),y)
	$(CP) plugins/examples/disass-use*  $(ROOTDIR)$(CONFDIR)
endif
endif
ifneq ($(CYGWIN),yes)
ifeq ($(CONFIG_PLUGIN),y)
	-$(SYMLINK) -r  -s $(ROOTDIR)$(BINDIR)/$(PROGRAM) $(ROOTDIR)$(CONFDIR)/utils/keyconfig
else
	-$(SYMLINK) -r  -s $(ROOTDIR)$(BINDIR)/$(PROGRAM) $(ROOTDIR)$(CONFDIR)/keyconfig
endif
else
ifeq ($(BIOSDISK),y)
	$(MAKE) -C biosdisk install ROOTDIR=$(ROOTDIR)
endif
ifeq ($(PDCURSES),)
	echo $(EXEPROGRAM) -k %1 %2 %3 %4 %5 %6 %7 %8 %9 > $(ROOTDIR)$(CONFDIR)/keyconfig.bat
endif
endif
ifeq ($(PDCURSES),)
	$(MKDIR) $(ROOTDIR)$(CONFDIR)/terminfo
	$(MKDIR) $(ROOTDIR)$(CONFDIR)/terminfo/r
	cp   terminfo/r/rxvt* $(ROOTDIR)$(CONFDIR)/terminfo/r
endif
	cp    LICENSE $(ROOTDIR)$(CONFDIR)
ifeq ($(OpSys),Windows)
	u2d     $(ROOTDIR)$(CONFDIR)/LICENSE
endif
	cp doc/datadir.txt $(ROOTDIR)$(CONFDIR)/README
	cp public.pgp $(ROOTDIR)$(CONFDIR)
ifeq ($(SYSTEM),Linux)
	cp bedkeys $(ROOTDIR)$(CONFDIR)
endif
ifeq ($(SYSTEM),FreeBSD)
	cp us.alt.kbd README.FreeBSD $(ROOTDIR)$(CONFDIR)
endif
ifeq ($(SYSTEM),SunOS)
	cp README.OpenSolaris $(ROOTDIR)$(CONFDIR)
endif
ifeq ($(HAS_FILE),y)
	$(CP) testmarks.bedm bedmagic bedmagic.short addmagic $(ROOTDIR)$(CONFDIR)
endif
ifneq ($(HAS_APPLICATIONS),)
	$(MKDIR) $(ROOTDIR)$(HAS_APPLICATIONS)
	cp progman/bed-binary-editor.desktop $(ROOTDIR)$(HAS_APPLICATIONS)/bed-binary-editor.desktop 
endif
ifeq ($(CONFIG_PROGMAN),y)
#	cp bed.xpm $(ROOTDIR)$(ICONPATH)
#	cp bedsmall.xpm $(ROOTDIR)$(ICONPATH)/mini/bed.xpm
	$(MKDIR) $(ROOTDIR)$(MENUPATH)
	cp bed.menu $(ROOTDIR)$(MENUPATH)/$(PROGRAM)
	chmod 0644 $(ROOTDIR)$(MENUPATH)/$(PROGRAM)

#	@rpm -q $(PROGRAM)|| echo Warning!! Desktop entries not created if no package $(PROGRAM) exists
endif
ifneq ($(CYGWIN),yes)

ifeq ($(SYSTEM),FreeBSD)
	$(SYMLINK) -r -f $(ROOTDIR)$(CONFDIR) $(ROOTDIR)$(CONFDIRLINK)
else
	$(SYMLINK) -r -T -f  $(ROOTDIR)$(CONFDIR) $(ROOTDIR)$(CONFDIRLINK)
endif
endif
ifeq ($(SYSTEM),Android)
	-$(MKDIR) $(ROOTDIR)$(BASEDIR)/tmp
	-chmod 01777 $(ROOTDIR)$(BASEDIR)/tmp
endif
ifneq ($(CYGWIN),yes)
	@cp uninstallhead $(ROOTDIR)$(CONFDIR)/uninstallbed.sh
	@FILES=`for afile in $(BINDIST); do  test -e $$afile -o -L $$afile&&echo $$afile ;done`;if test . != .$(ROOTDIR); then SLASHROOT=`echo $(ROOTDIR)| sed -e 's/\\//\\\\\\//g'`;fi;find  $$FILES ! -type d -print |if test . != .$(ROOTDIR);then sed -e "s/$$SLASHROOT//g";else cat;fi |xargs echo $(REMOVE) ' ' >> $(ROOTDIR)$(CONFDIR)/uninstallbed.sh ;find  $$FILES -type d  -a  -print| if test . != .$(ROOTDIR);then sed -e "s/$$SLASHROOT//g";else cat;fi |$(SORT) -r|xargs echo $(RMDIR) ' ' >> $(ROOTDIR)$(CONFDIR)/uninstallbed.sh
	@echo Uninstall with sh $(ROOTDIR)$(CONFDIR)/uninstallbed.sh
endif
	@echo Binary: '$(ROOTDIR)$(BINDIR)/$(EXEPROGRAM)'
	@echo Support files: $(ROOTDIR)$(CONFDIR)



cleanhere:
	-rm  $(REGEX_DIR)/regex.o hosttest$(BUILDEXEEXT) has_appl$(BUILDEXEEXT) has_file$(BUILDEXEEXT)
clean: cleanhere
	$(MAKE) -C src clean
	$(MAKE) -C utils clean
	$(MAKE) -C plugins clean
	$(MAKE) -C x11 clean
	$(MAKE) -C biosdisk clean
	-$(MAKE) -C doc clean
	-$(MAKE) -C man2html clean


realclean: cleanhere
	-rm $(CONFFILE)  config.cache config.bak config.log config.status  bedrc buildonce getsize
	 $(MAKE) -C x11 clean
	$(MAKE) -C src realclean
	- $(MAKE) -C doc realclean
	- $(MAKE) -C man2html clean
	 $(MAKE) -C utils realclean
	 $(MAKE) -C plugins realclean
	 $(MAKE) -C biosdisk realclean
	-rm  $(REGEX_DIR)/regex.o


echo:
	echo $(BINDIST)
.PHONY: %.dist %.bindist %.srcdist %.html
HTMLPATH=../html
DISTPATH=$(HTMLPATH)
TGZSUF=.tar.xz
SRCBASE=$(PROGRAM)-$(VERSION).src
SRCARGFILE=$(SRCBASE)$(TGZSUF)
SRCLSMFILE=$(SRCBASE).lsm
SRCASCFILE=$(SRCBASE).asc
#s/$(TGZSUF)/$(TGZSUF)/g


SOURCEFILE=$(DISTPATH)/download/$(PROGRAM)-$(VERSION).src$(TGZSUF) 
ifeq ($(CONFIG_STATIC),y)
ELFBASE=$(PROGRAM)-$(VERSION).$(SYSTEM).ELF-static$(ELFSIZE)
else
#ELFBASE=$(PROGRAM)_$(VERSION)-$(SYSTEM)
ELFBASE=$(PROGRAM)-$(VERSION).$(SYSTEM)
endif
ELFARGFILE=$(ELFBASE)$(ELFSIZE)$(TGZSUF) 
ELFLSMFILE=$(ELFBASE).lsm
ELFASCFILE=$(ELFBASE).asc
WIN32ARGFILE=$(PROGRAM)-$(VERSION).win32.zip
WIN95ARGFILE=$(PROGRAM)-$(VERSION).win95.zip
#NWIN32ARGFILE=$(PROGRAM)-$(VERSION).win32ncurses.zip
NWIN32ARGFILE=$(PROGRAM)-$(VERSION).win32ncuronly.zip

WIN64ARGFILE=$(PROGRAM)-$(VERSION).win64.zip
NWIN64ARGFILE=$(PROGRAM)-$(VERSION).win64ncuronly.zip


FREEBSDARGFILE=$(PROGRAM)-$(VERSION).FreeBSD64.tbz
#FREEBSDARGFILE=$(PROGRAM)-0.2.22.FreeBSD64$(TGZSUF)
#FREEBSDARGFILE=$(PROGRAM)-0.2.22.FreeBSD64$(TGZSUF)
OPENSOLARISFILE=$(PROGRAM)-$(VERSION).SunOS.tar.xz
STATICARGFILE=$(PROGRAM)-$(VERSION).bin.ELF-static$(TGZSUF)
#NONSTATICARGFILE32=$(PROGRAM)-$(VERSION).Linux32$(TGZSUF)
#NONSTATICARGFILE64=$(PROGRAM)-$(VERSION).Linux64$(TGZSUF)
NONSTATICARGFILE64=$(PROGRAM)_$(VERSION)_amd64.deb
NONSTATICARGFILE32=$(PROGRAM)_$(VERSION)_i386.deb
NONSTATICARGFILE_ARMHF=$(PROGRAM)_$(VERSION)_armhf.deb
ANDROIDARGFILE=$(PROGRAM)-$(VERSION)-arm-android-17.tar.gz
RPMFILE=bed-$(VERSION)-1.i686.rpm

#LSMFILE=$(PROGRAM)-$(VERSION).lsm
FULLELFFILE=$(DISTPATH)/download/$(ELFARGFILE)
#PGPSIGNPROG=gpg -s --use-embedded-filename -a -b -u 0x94BA03AE 
#PGPSIGNPROG=gpg2 -s --use-embedded-filename -b -u 0x94BA03AE 

#PGPSIGNPROG=gpg2 -s   -b -u 0x94BA03AE 

# --use-embedded-filename

#  --comment string

#       --no-comments

#--clearsign


#PGPSIGNPROG= pgps -a -b -u 0x94BA03AE 

PGPSIGNPROG=gpg --cert-digest-algo=SHA256 -s -a  -b -u 0x94BA03AE -u 0x65D385A5 

mkuninstall:
	@cp uninstallhead $(CONFDIR)/uninstallbed.sh
	@FILES=`for afile in $(BINDIST); do  test -e $$afile -o -L $$afile&&echo $$afile ;done`; find  $$FILES ! -type d|xargs echo $(REMOVE) ' ' >> $(CONFDIR)/uninstallbed.sh ;find  $$FILES -type d|$(SORT) -r|xargs echo $(RMDIR) ' ' >> $(CONFDIR)/uninstallbed.sh
#	find  $(BINDIST) -type f|xargs 'echo rm -f '
#	find  $(BINDIST) -type d|$(SORT) -r|xargs 'echo rmdir '

%.bindist: $(BINARIES)
	mkdir -p $*/download
	tar --use-compress-program="xz -ze" -cf $*/download/$(ELFARGFILE)   $(BINDIST) 
#	env VERSION=$(VERSION) ELFBASE=$(ELFBASE) SRCBASE=$(SRCBASE) DISTPATH=$*/download sh ./mklsmelf > $*/download/$(ELFLSMFILE)
%.srcdist:
	mkdir -p $*/download
	tar --use-compress-program="xz -ze" -cf  $*/download/$(PROGRAM)-$(VERSION).src$(TGZSUF)  -C ../  $(PROGRAM)-$(VERSION) 
#	env  ELFBASE=$(ELFBASE) SRCBASE=$(SRCBASE) VERSION=$(VERSION) DISTPATH=$*/download bash ./mklsm > $*/download/$(SRCLSMFILE)
%.html: mkbed 
	mkdir -p $*
	$(MAKE) -C doc bed.html
	cp doc/bed.html $*/bed.1.html
	$(MAKE) -C doc menu.html
	env SRCARGFILE=$(SRCARGFILE) WIN32ARGFILE=$(WIN32ARGFILE)  WIN95ARGFILE=$(WIN95ARGFILE)  OPENSOLARISFILE=$(OPENSOLARISFILE) FREEBSDARGFILE=$(FREEBSDARGFILE) NONSTATICARGFILE32=$(NONSTATICARGFILE32) ANDROIDARGFILE=$(ANDROIDARGFILE) NONSTATICARGFILE_ARMHF=$(NONSTATICARGFILE_ARMHF) NONSTATICARGFILE64=$(NONSTATICARGFILE64) STATICARGFILE=$(STATICARGFILE) ELFBASE=$(ELFBASE) SRCBASE=$(SRCBASE) VERSION=$(VERSION) DISTPATH=$*/download bash ./mkbed | sh dseonlyext.sh >$*/download.html
	sh dseext.sh <$*/download.html > $*/downloaddse.html
	env  LOWVERSION=$(LOWVERSION) LSMFILE=$(LSMFILE)  ELFBASE=$(ELFBASE) SRCBASE=$(SRCBASE) VERSION=$(VERSION) DISTPATH=$*/download bash ./mkoldpage.sh > $*/oldbeds.html
	cp doc/menu.html $*/menu.html

#	env  WIN32ARGFILE=$(WIN32ARGFILE)  OPENSOLARISFILE=$(OPENSOLARISFILE) FREEBSDARGFILE=$(FREEBSDARGFILE) NONSTATICARGFILE32=$(NONSTATICARGFILE32) NONSTATICARGFILE64=$(NONSTATICARGFILE64) STATICARGFILE=$(STATICARGFILE) ELFBASE=$(ELFBASE) SRCBASE=$(SRCBASE) VERSION=$(VERSION) DISTPATH=$*/download bash ./mknewlsm > $*/download/$(LSMFILE)
%.dist: %.srcdist %.bindist %.sign
	echo $*




#s/FREEBSDARGFILE/OPENSOLARISFILE/g

%.sign:
	$(PGPSIGNPROG)   --comment $(SRCARGFILE) $*/download/$(SRCARGFILE) 
	$(PGPSIGNPROG)   --comment $(WIN64ARGFILE) $*/download/$(WIN64ARGFILE) 
	$(PGPSIGNPROG)   --comment $(NWIN64ARGFILE) $*/download/$(NWIN64ARGFILE) 
	$(PGPSIGNPROG)   --comment $(WIN32ARGFILE) $*/download/$(WIN32ARGFILE) 
	$(PGPSIGNPROG)   --comment $(NWIN32ARGFILE) $*/download/$(NWIN32ARGFILE) 
	$(PGPSIGNPROG)   --comment $(NONSTATICARGFILE32) $*/download/$(NONSTATICARGFILE32) 
	$(PGPSIGNPROG)   --comment $(NONSTATICARGFILE64) $*/download/$(NONSTATICARGFILE64) 
	$(PGPSIGNPROG)   --comment $(NONSTATICARGFILE_ARMHF) $*/download/$(NONSTATICARGFILE_ARMHF) 
	$(PGPSIGNPROG)   --comment $(ANDROIDARGFILE) $*/download/$(ANDROIDARGFILE) 
#	make $*/download/$(LSMFILE) 

#	$(PGPSIGNPROG)  $*/download/$(STATICARGFILE)
#	env  WIN32ARGFILE=$(win32argfILE)  OPENSOLARISFILE=$(OPENSOLARISFILE) FREEBSDARGFILE=$(FREEBSDARGFILE) NONSTATICARGFILE32=$(NONSTATICARGFILE32) NONSTATICARGFILE64=$(NONSTATICARGFILE64) STATICARGFILE=$(STATICARGFILE) ELFBASE=$(ELFBASE) SRCBASE=$(SRCBASE) VERSION=$(VERSION) DISTPATH=$*/download bash ./mknewlsm > $*/download/$(LSMFILE)

%.lsm: ./settings
	env SRCARGFILE=$(SRCARGFILE) WIN32ARGFILE=$(WIN32ARGFILE)  WIN95ARGFILE=$(WIN95ARGFILE)  OPENSOLARISFILE=$(OPENSOLARISFILE) FREEBSDARGFILE=$(FREEBSDARGFILE) NONSTATICARGFILE32=$(NONSTATICARGFILE32) NONSTATICARGFILE64=$(NONSTATICARGFILE64) STATICARGFILE=$(STATICARGFILE) ELFBASE=$(ELFBASE) SRCBASE=$(SRCBASE) VERSION=$(VERSION) DISTPATH=../html/download bash ./mknewlsm > $*.lsm

=== biosdisk/Makefile ===
include ../config
# I saw no problems with -O2 now I removed some inline statements
# but I did most of my test without optimalisation. And the first
# release gave unexpected problems optimalised.
CFLAGS+= -Wno-unused-variable
ifeq ($(CONFIG_DEBUG),n)
	LDFLAGS+= -s
	CFLAGS+=  $(OPTS)  
else
	ifeq ($(CONFIG_DEBUG),o)
		LDFLAGS+= -O2 -g
		CFLAGS+=  $(OPTS) -g -O2
	else
		CFLAGS+=  $(OPTS) -g
		LDFLAGS+= -g
	endif
endif
all: biosdisk32.dll biosdisk.dll
biosdisk32.o: biosdisk32.c biosdisk.h biosthun.h 
	gcc  $(CFLAGS) -c biosdisk32.c 
biosdisk32.s: biosdisk32.c biosdisk.h biosthun.h 
	gcc -S $(CFLAGS) biosdisk32.c -o biosdisk32.s  
rmbioslib: rmbioslib.c biosdisk32.dll
	gcc -O3 -s rmbioslib.c biosdisk32.dll -o rmbioslib
biosdisk32.i: biosdisk32.c biosdisk.h biosthun.h 
	gcc $(CFLAGS) -E biosdisk32.c  -o biosdisk32.i
biosdisk.dll: biosdisk.c biosdisk.h biosthun.h biosdisk.def
	maker  -f biosdisk.mak 
	tdstrip biosdisk.dll


biosdisk32.dll: biosdisk32.o biosdisk32.def 
	gcc  -shared --dll $(LDFLAGS) biosdisk32.def biosdisk32.o  -o biosdisk32.dll 

install: biosdisk32.dll biosdisk.dll
	-mkdir -p $(ROOTDIR)$(CONFDIR)
	-cp biosdisk32.dll biosdisk.dll $(ROOTDIR)$(CONFDIR)

clean:
	-rm biosdisk32.dll biosdisk32.o biosdisk.obj biosdisk32.lib  rmbioslib.obj
realclean: clean
	-rm  biosdisk.dsw rmbioslib.exe

echo:
	echo $(CFLAGS)
	echo $(OPT)
	echo $(LDFLAGS)

=== doc/Makefile ===
include ../config
include ../prognames.mk
ifeq ($(FULLUNIX)$(HAS_NROFF),ny)
all: datadir.txt bed.1 bed.html bed.txt
else

ifeq ($(SYSTEM),Linux)
all: datadir.txt bed.1.gz
else
all: datadir.txt bed.1
endif
endif
ifneq ($(CYGWIN),yes)
GLOBALCONFIG=$(shell echo '$(GLOBALCONFFILE)'| sed -e 's/\//\\\//g' )
PERSCONFIG=$(shell echo '$(PERSCONFFILE)'| sed -e 's/\//\\\//g' )
CONFDIRLINKER=$(shell echo '$(CONFDIRLINK)'| sed -e 's/\//\\\//g' )
else
#PERSCONFIG=\%LOCALAPPDATA\%\/$(CONFFILE)
PERSCONFIG=\%LOCALAPPDATA\%\\\\$(CONFFILE)
CONFDIRLINKER=$(shell echo `cygpath --windows $(CONFDIRLINK)` | sed -e 's/\\/\\\\\\\\/g' )
GLOBALCONFIG=$(shell echo `cygpath --windows $(GLOBALCONFFILE)` | sed -e 's/\\/\\\\\\\\/g' )
endif


vars:
	echo $(PERSCONFIG)
	echo $(CONFDIRLINKER)
	echo $(CONFDIRLINK)
	
bed.txt: bed.html Makefile
	(lynx  -nolist -dump bed.html||nroff -c -mandoc bed.1 ) > bed.txt
ifeq ($(CYGWIN),yes)
	u2d bed.txt
endif 

datadir.txt: .datadir.txt ../.common.txt
	cat .datadir.txt > datadir.txt
	sed 's/CONFDIRLINK/$(CONFDIRLINKER)/g' < ../.common.txt >>datadir.txt
ifeq ($(CYGWIN),yes)
	u2d datadir.txt
endif 
echos:
	echo $(MKDIR)  $(ROOTDIR)$(MANDIR)
	echo $(CP) bed.html $(ROOTDIR)$(CONFDIR)/bed.html
	echo test -d /usr/man/man1  $(CP) bed.1 /usr/man/man1 
install:
	-$(MKDIR)  $(ROOTDIR)$(MANDIR)
ifeq ($(FULLUNIX),y)
ifeq ($(SYSTEM),Linux)
	$(CP) bed.1.gz $(ROOTDIR)$(MANDIR)/$(PROGRAM).1.gz
else
	$(CP) bed.1 $(ROOTDIR)$(MANDIR)/$(PROGRAM).1
endif
ifeq ($(CONFIG_XBED),y)
ifeq ($(SYSTEM),Linux)
	$(CP) xbed.1.gz $(ROOTDIR)$(MANDIR)/$(XPROGRAM).1.gz
else
	$(CP) xbed.1 $(ROOTDIR)$(MANDIR)/$(XPROGRAM).1
endif
endif
#	-chmod 0644 $(ROOTDIR)$(MANDIR)/$(XPROGRAM).1 $(ROOTDIR)$(MANDIR)/$(PROGRAM).1
ifeq ($(CROSS_COMPILING),)
	-man -F bed 2>/dev/null >&2
endif
else
	$(CP) bed.html $(ROOTDIR)$(CONFDIR)/bed.html
ifneq ($(ROOTDIR),)
	-$(MKDIR)  -p $(ROOTDIR)$(MANDIR)
	$(CP) bed.1 $(ROOTDIR)$(MANDIR)
else
	-(test -d $(ROOTDIR)/usr/share/man/man1 && $(CP) bed.1 $(ROOTDIR)/usr/share/man/man1 )|| (test -d $(ROOTDIR)/usr/man/man1 && $(CP) bed.1 $(ROOTDIR)/usr/man/man1 )

endif
endif

realclean:
	-rm bed.txt bed.1 bed.1.gz prochelp.tus bed.1.tus1 bed.1.tus2 bed.html.tus2  bed.html.tus1 bed.html menu.html datadir.txt google$(BUILDEXEEXT) bed.tus3.html

sections.tus: sections.sed menu.html
	sed -n -f  sections.sed menu.html > sections.tus
bed.1: bed.1.tus2 Makefile
	sed -e '{s/PROGRAM/$(PROGRAM)/g;s/VERSION/$(VERSION)/g;s/CONFDIRLINK/$(CONFDIRLINKER)/g;s/GLOBALCONFIG/$(GLOBALCONFIG)/g;s/PERSCONFIG/$(PERSCONFIG)/g;s/proconly \(\<[^ 	]*\>\)/\1/g;s/prockey \(\<[^ 	]*\>\)/Alt-t,d,\1/g; }' < bed.1.tus2 > bed.1
oldbed.html: bed.1 
	$(MAN2HTML) -M /cgi-bin/man2html bed.1|sed -e '{s/Content-type: text\/html//g;s/^.*Return to Main Contents.*$$//g;s/^Section: User Commands.*$$//g;s/<BODY>/<body text="#000000" bgcolor="#FFFFFF" link="#0000EF" vlink="#55188A" alink="#FF0000">/g;}' > oldbed.html 
#menu.html:bed.html.tus2 menu.html.instart menu.html.inend mkindex.sh menu.html.nahead trackingcode.txt
menu.html:bed.html.tus2 menu.html.instart menu.html.inend mkindex.sh menu.html.nahead 
	bash mkindex.sh
view: bed.1
	nroff -mandoc bed.1|less
bed.1.gz:bed.1
	-rm bed.1.gz
	gzip -c bed.1 > bed.1.gz
bed.1.tus1: bed.1.in2a bed.1.in2b options.sed 
	cat bed.1.in2a > bed.1.tus1
	(../src/bed -h||bed -h)|sed  -f options.sed  >> bed.1.tus1
	cat bed.1.in2b >> bed.1.tus1
bed.1.tus2: bed.1.in1 ../description bed.1.tus1 prochelp.tus bed.1.inend
	sed -f ../src/chhelp < bed.1.in1 > bed.1.tus2
	sed -e 's/^[	 ]*//g' < ../description >> bed.1.tus2
	sed -f ../src/chhelp < bed.1.tus1 >> bed.1.tus2
	cat prochelp.tus >> bed.1.tus2
	sed -f ../src/chhelp < bed.1.inend >> bed.1.tus2
bed.html.tus2: bed.html.tus1	html1.sed ../src/chhelp html3.sed $(MAN2HTML) 
	cat bed.html.tus1|sed -e '{s/PROGRAM/$(PROGRAM)/g;s/VERSION/$(VERSION)/g;s/CONFDIRLINK/$(CONFDIRLINKER)/g;s/GLOBALCONFIG/$(GLOBALCONFIG)/g;s/PERSCONFIG/$(PERSCONFIG)/g;}' |$(MAN2HTML)   -HXYHOSTYX -M QRPATHRQ |sed -f html1.sed |sed -f ../src/chhelp|sed -f html3.sed  > bed.html.tus2
	cat bed.html.intail >> bed.html.tus2
google: google.cc
	$(TOBUILDCXX) $(BUILDCXXFLAGS) $< -o $@

bed.html: bed.html.tus2 sections.tus 
	sed -f sections.tus < bed.html.tus2| sed 's/\(<[Aa][^>]*http[^>]*\)>/\1 TARGET="_top">/g' > bed.html
#	sed -f sections.tus < bed.html.tus2 > bed.tus3.html
#	./google bed.tus3.html trackingcode.txt > bed.html

bed.html.tus1: bed.1.in1 ../description bed.1.tus1 prochelp.tus bed.1.inend bed.html.sed
	cat bed.1.in1 > bed.html.tus1
	sed -e 's/^[	 ]*//g' < ../description >> bed.html.tus1
	cat  bed.1.tus1  >> bed.html.tus1
	cat ../src/helpdata.in ../plugins/examples/plughelp ../plugins/examples/plugman |sed -f bed.html.sed >> bed.html.tus1
	cat bed.1.inend >>bed.html.tus1

prochelp.tus: ../plugins/examples/plugman ../src/helpdata ../src/todoc.sed
	cat ../src/helpdata ../plugins/examples/plugman |sed -f ../src/todoc.sed  > prochelp.tus

../plugins/examples/plugman:
	$(MAKE) -C../plugins/examples/ plugman
../src/helpdata:
	$(MAKE) -C ../src helpdata

try:
	sed -n -e 's/hallo/this\n\
is\n\
een\n\
zin/gp'



../man2html/Makefile:
	(cd ../man2html; ./conf_script	Makefile)

../man2html/man2html: ../man2html/Makefile
	(cd ../man2html; $(MAKE))

=== man2html/Makefile ===
include /home/jka/src/bed-3.0.0/man2html/../build
CC = cc
CFLAGS += -Wall -Wstrict-prototypes -Wmissing-prototypes
OBJECTS = man2html.o cgibase.o abbrev.o strdefs.o
EXEEXT = $(BUILDEXEEXT)
bindir = $(DESTDIR)$(PREFIX)/usr/bin
mandir = $(DESTDIR)$(PREFIX)${prefix}/share/man
vardir = $(DESTDIR)$(PREFIX)/var
httpdir = $(DESTDIR)$(PREFIX)/home/httpd
cgiowner = nobody
cgigroup = nobody

all: man2html$(EXEEXT) hman

man2html$(EXEEXT):	$(OBJECTS)
	$(CC) $(LDFLAGS) -o man2html$(EXEEXT) $(OBJECTS)

# man2html:	../src/version.h

# This installs the man2html utility
install:	man2html$(EXEEXT)
	mkdir -p $(bindir)
	install -m 755 man2html$(EXEEXT) $(bindir)
	mkdir -p $(mandir)/man1
	install -m 644 man2html.1 $(mandir)/man1/man2html.@man1ext@

install-scripts: install-man-scripts install-glimpse-stuff install-hman

# These are the scripts that allow pointing a browser at
#   http://localhost/cgi-bin/man/man2html
# to work.
install-man-scripts:
	mkdir -p $(httpdir)/cgi-bin/man
	mkdir -p $(httpdir)/cgi-aux/man
	install -m 755 scripts/cgi-bin/man/* $(httpdir)/cgi-bin/man
	install -m 644 scripts/cgi-aux/man/* $(httpdir)/cgi-aux/man
	install -d -o $(cgiowner) -g $(cgigroup) -m 775 $(vardir)/man2html
# (aux was renamed to cgi-aux since aux causes problems under DOS)

# If you have installed glimpse, and have compressed man pages,
# then perhaps you also want these filters.
install-glimpse-stuff:
	install -m 644 glimpse_filters $(vardir)/man2html/.glimpse_filters

# In order not to have to type a long command like
#   netscape http://localhost/cgi-bin/man/man2html?section+topic
# or
#   lynx lynxcgi:/home/httpd/cgi-bin/man/man2html?section+topic
# it is convenient to have some shell script as a wrapper.
# The script hman can be aliased to man. It uses an environment
# variable MANHTMLPAGER to find out which browser you use, and
# you can set MANHTMLHOST if the pages are not on localhost.
hman: hman.sh
	rm -f hman
	sed -e 's,%version%,@version@,' hman.sh > hman

install-hman: hman
	install -m 555 hman $(bindir)/hman
	install -m 644 hman.1 $(mandir)/man1/hman.@man1ext@

clean:
	rm -f core hman man2html$(EXEEXT) $(OBJECTS) *~

spotless:	clean
	rm -f Makefile

$(OBJECTS): defs.h

=== misc/Makefile ===
include ../config
ifeq ($CONFDIR),)
	export MISCDIR=.
else
	export MISCDIR=$(CONFDIR)/misc
endif

GENERAL= README.txt filepermissionbits.bedda char2.bedda char2b.bedda hexasc.bedda pushlpushl.bedda
ELFTYPE= dynsym.bedda sectionheader.bedda symtab.bedda elfheader32.bedda elfheader64.bedda programheaderELF32.bedda programheaderELF64.bedda
BEDFORMATS=macroheader.bedda markheader.bedda
WIN32TYPE= win32sections.bedda #dosheader.bedda
LINUXTYPE=wtmp-linux.bedda rpm.bedda
FREEBSDTYPE=wtmp-freebsd.bedda
install: 
	-$(MKDIR) $(ROOTDIR)$(MISCDIR)
	$(CP) $(GENERAL) $(ROOTDIR)$(MISCDIR)
ifeq ($(USES_ELF),y)
	$(CP) $(ELFTYPE) $(ROOTDIR)$(MISCDIR)
endif
ifeq ($(SYSTEM),Linux)
	$(CP) $(LINUXTYPE) $(ROOTDIR)$(MISCDIR)
endif
ifeq ($(SYSTEM),FreeBSD)
	$(CP) $(FREEBSDTYPE) $(ROOTDIR)$(MISCDIR)
endif
	$(CP) $(WIN32TYPE) $(ROOTDIR)$(MISCDIR)
	

#	mkdir  $(MISCDIR)

=== pkg/Makefile ===
# New ports collection makefile for:    bed
# Date created:         2001/05/07
# Whom:                 binaryeditor+bed@eml.cc
#
# $FreeBSD$
#

PORTNAME=	bed
PORTVERSION=	3.0.0
CATEGORIES=	editors
MASTER_SITES=		${MASTER_SITE_SUNSITE}
MASTER_SITE_SUBDIR=	apps/editors/terminal/
EXTRACT_SUFX=		.src.tgz

MAINTAINER=	binaryeditor@eml.cc

COMMENT=	pkg-comment

GNU_CONFIGURE=	yes

USE_GMAKE=	yes

MAN1=  bed.1
MANCOMPRESSED= no


post-configure:
	${ECHO} 'CONFIG_DEBUG=n' >> ${WRKSRC}/config
	${ECHO} 'CONFIG_MMAP=y' >> ${WRKSRC}/config
	${GMAKE} -C ${WRKSRC} dep

.include <bsd.port.mk>
pkg-descr: ../description
	${SED} 's/^[ 	]*\(.*\)$$/\1/' < ../description > pkg-descr

config: pkg-plist distinfo
DISTSRC=${PORTSDIR}/distfiles/bed-$(PORTVERSION)$(EXTRACT_SUFX)
ORSRC=../../html/download/bed-$(PORTVERSION)$(EXTRACT_SUFX)
distinfo: ${PORTSDIR}/distfiles/bed-$(PORTVERSION)$(EXTRACT_SUFX)
	PWDHERE=`pwd`;cd ${PORTSDIR}/distfiles/; ${MD5} bed-$(PORTVERSION)$(EXTRACT_SUFX) > $$PWDHERE/distinfo
pkg-plist: Makefile
	${GMAKE} -C ../ pkg/pkg-plist
${PORTSDIR}/distfiles/bed-$(PORTVERSION)$(EXTRACT_SUFX): ../../html/download/bed-$(PORTVERSION)$(EXTRACT_SUFX)
	${CP} $(ORSRC)  ${PORTSDIR}/distfiles/bed-$(PORTVERSION)$(EXTRACT_SUFX)

=== plugins/Makefile ===
export LC_ALL=C
include ../config
ifeq ($(CONFIG_LARGEFILES),y)
CFLAGS := $(CFLAGS) -DLARGEFILES
endif
ifeq ($CONFDIR),)
	export PLUGINDIR=.
else
	export PLUGINDIR=$(CONFDIR)/plugins
endif


GENERAL=$(PLUGINDIR)/plugin.cpp
HEADERS=$(PLUGINDIR)/faked.h $(PLUGINDIR)/mainprocedures.h $(PLUGINDIR)/screenpart.h $(PLUGINDIR)/offtypes.h  $(PLUGINDIR)/global.h $(PLUGINDIR)/typelist.h $(PLUGINDIR)/filter.h


#ALLFILES= Makefile config  faked.h filter.h global.h offtypes.h plugin.cpp procedures.h screenpart.h typelist.h
ALLFILES = Makefile faked.h global.h plugin.cpp 
FROMSRCDIR=ascii.h contain.h filter.h dialog.h hassub.h multidigit.h offtypes.h mainprocedures.h repeat.h screen.h screenpart.h type.h typelist.h views.h digitstring.h config.h varmacro.h  readconfig.h



CFLAGS := $(CFLAGS) -g



#%.plug: %.o
#	gcc $(CFLAGS) -shared $< -o $@
#	chmod a-x $@
#%.o: %.cpp  $(GENERAL) $(HEADERS)
#	gcc $(CFLAGS) -DSOURCEFILENAME=\"$<\" -c $(GENERAL) -o $@
all: mainprocedures.h

mainprocedures.h:../src/mainprocedures.h
	ln -fs ../src/mainprocedures.h $@
../src/mainprocedures.h:
	$(MAKE) -C ../src mainprocedures.h

install:
	-mkdir -p $(ROOTDIR)$(CONFDIR)
	-mkdir  -p $(ROOTDIR)$(PLUGINDIR)
	cp ../config $(ROOTDIR)$(CONFDIR)
	cp -f $(ALLFILES) $(ROOTDIR)$(PLUGINDIR)
	(CURDIR=`pwd`;cd $(ROOTDIR)$(PLUGINDIR) ;chmod  0644 $(ALLFILES);cd $$CURDIR)
	(cd ../src; $(CP) $(FROMSRCDIR) $(ROOTDIR)$(PLUGINDIR); $(CP) definesonly.h $(ROOTDIR)$(PLUGINDIR)/defines.h)

	$(MAKE) -C examples install

realclean:
	$(MAKE) -C examples realclean

clean:
	$(MAKE) -C examples clean

dep:
	$(MAKE) -C examples dep

=== regex-0.13/Makefile ===
# Makefile for regex.
# 
# Copyright (C) 1992, 1993 Free Software Foundation, Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

version = 0.13

# You can define CPPFLAGS on the command line.  Aside from system-specific
# flags, you can define:
#   -DREGEX_MALLOC to use malloc/realloc/free instead of alloca.
#   -DDEBUG to enable the compiled pattern disassembler and execution
#           tracing; code runs substantially slower.
#   -DEXTRACT_MACROS to use the macros EXTRACT_* (as opposed to
#           the corresponding C procedures).  If not -DDEBUG, the macros
#           are used.
CPPFLAGS = 

# Likewise, you can override CFLAGS to optimize, use -Wall, etc.
CFLAGS = -g

# Ditto for LDFLAGS and LOADLIBES.
LDFLAGS =
LOADLIBES =

srcdir = .


CC = arm-linux-androideabi-gcc
DEFS = -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DPACKAGE_URL=\"\" -DSTDC_HEADERS=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_MEMORY_H=1 -DHAVE_STRINGS_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_UNISTD_H=1 -D__EXTENSIONS__=1 -D_ALL_SOURCE=1 -D_GNU_SOURCE=1 -D_POSIX_PTHREAD_SEMANTICS=1 -D_TANDEM_SOURCE=1 -DHAVE_GETMNTENT=1 -DSTDC_HEADERS=1 -DHAVE_STRING_H=1 -DHAVE_ALLOCA_H=1 -DHAVE_ALLOCA=1

SHELL = /bin/sh

subdirs = doc test

default all:: regex.o
.PHONY: default all


regex.o: regex.c xregex.h xregex2.h
	$(CC) $(CFLAGS) $(CPPFLAGS) $(DEFS) -I. -I$(srcdir) -c $<

configure: configure.in
	autoconf

config.status: configure
	sh configure --no-create

Makefile: Makefile.in config.status
	sh config.status

makeargs = $(MFLAGS) CPPFLAGS='$(CPPFLAGS)' CFLAGS='$(CFLAGS)' CC='$(CC)' \
DEFS='$(DEFS)' LDFLAGS='$(LDFLAGS)' LOADLIBES='$(LOADLIBES)'

default all install TAGS check::
	for d in $(subdirs); do (cd $$d; $(MAKE) $(makeargs) $@); done

# 11/15/06 jpr5: effort to force this makefile to clean up completely
#                re-organized the clean statements
#                added config.cache and config.log to targets                 

clean mostlyclean:
	for d in $(subdirs); do (cd $$d; $(MAKE) $(makeargs) $@); done
	rm -f *.o

extraclean realclean distclean:
	for d in $(subdirs); do (cd $$d; $(MAKE) $(makeargs) $@); done
	rm -f patch* *~* *\#* *.orig *.rej *.bak core a.out
	rm -f Makefile config.status config.cache config.log regex.o

.PHONY: install mostlyclean clean distclean extraclean realclean TAGS check


# Prevent GNU make 3 from overflowing arg limit on system V.
.NOEXPORT:

distfiles = AUTHORS ChangeLog COPYING INSTALL NEWS README \
            *.in configure regex.c regex.h 
distdir = regex-$(version)
distargs = version=$(version) distdir=../$(distdir)/$$d
dist: TAGS configure
	@echo "Version numbers in: Makefile.in, ChangeLog, NEWS,"
	@echo "  regex.c, regex.h,"
	@echo "  and doc/xregex.texi (if modified)."
	rm -rf $(distdir)
	mkdir $(distdir)
	ln $(distfiles) $(distdir)
	for d in $(subdirs); do (cd $$d; $(MAKE) $(distargs) dist); done
	tar czhf $(distdir).tar.Z $(distdir)
	rm -rf $(distdir)
.PHONY: dist

=== src/Makefile ===
include ../config
include rules.mk
ifeq ($(PDCURSES)$(CYGWIN),1yes)
WINPD=y
endif
LIBS+= $(CURSESLIB) $(EXTRALIBS) $(OTHERLIBS)# -L/mnt/chicken/lib -L/mnt/chicken/usr/lib
CFLAGS+=  -D_GNU_SOURCE -DNEWTERM #-DUSE_NEW # -DMEMORY_TRACE	#-DREAD0x2x4DATATYPE #-DSEARCHTIME #-DUSE_NEW #-DMEMORY_TRACE	

OPTS:= $(OPTS) 
LIBPATH=-L. 
INLINKLISTER= ../plugins/examples/inlinklist
INLINKLIST= compileinlink
MKINLINK_H=mkinlink_h
ININLINKLIB= $(patsubst %,../plugins/examples/%,$(shell cat $(INLINKLISTER) ))
#CLEANOBJECTS=$(OBJECTS)
OBJECTS+=$(ININLINKLIB)
PROGCC=$(GXX)
ifeq ($(CYGWIN),yes)
SORT=/usr/bin/sort 
else
SORT:=sort 
endif
CP=cp -f -b
SHELL:=bash
BIN2BYTE:= ../utils/bin2byte
MV=mv

#CFLAGS:= -Wall $(CFLAGS) -DSETSCRREGBUG # -DALWAYSEXPLORESIZE 
#CFLAGS:=  -Wno-deprecated  $(CFLAGS) -DSETSCRREGBUG # -DALWAYSEXPLORESIZE 
#CFLAGS:= -Wunused  -Wunused-value  -funsigned-char  $(CFLAGS) -DSETSCRREGBUG # -DALWAYSEXPLORESIZE 
#CFLAGS:= -Wall    -funsigned-char  $(CFLAGS) -DSETSCRREGBUG # -DALWAYSEXPLORESIZE 
CFLAGS:= -Wall     $(CFLAGS) -DSETSCRREGBUG # -DALWAYSEXPLORESIZE 
ifeq ($(SYSTEM),Linux)
#CFLAGS+= -DPROCLOCKSBUG  -DATOIBUG
#CFLAGS+= -DPROCLOCKSBUG  -DATOIBUG
endif

#-DENDOFLINEBUG
OLDCFLAGS:=$(CFLAGS)
CFLAGS +=$(OPTS) 

LDFLAGS:=$(OPTS) $(LDFLAGS)
CPPFLAGS=$(CFLAGS)
# *** NORMALLY NOTHING HAS TO BE CHANGED BELOW THIS LINE

OBJ := repeat.o rbtree.o memory.o editor.o   dialog.o glob.o expandfilename.o readconfig.o  getfree.o getlabel.o  screenpart.o  marks.o digitstring.o   parts.o main.o    keyproc.o marken.o procview.o menus.o inout.o move.o window.o edit.o file.o suspend.o select.o undo.o screen.o search.o onlykey.o  editup.o  cursesinit.o input.o contain.o withcontain.o filter.o  ascii.o  multidigit.o macros.o editmacros.o typelist.o $(OBJ) keyinput.o  hassub.o savedatatype.o menufuncs.o support.o desturbe.o gethelp.o disk.o   memed.o  gnusearch.o unitsearch.o bytesearch.o  gnuasciiregex.o showlist.o  times.o
ifeq ($(USE_HYPERSCAN),1)
OBJ +=hyperscan.o 
endif

ifeq ($(USE_RE2),1)
OBJ += re2search.o  
endif
BUILDOBJ := hostreadhelp.o hostgetlabel.o

ifeq ($(SYSTEM),FreeBSD)
OBJ+=prevention.o
endif

ifneq ($(WINPD),y)
OBJ+=keyconfig.o 
endif
CPPFILES=  debug.cpp editlimits.cpp editor.cpp dialog.cpp getfree.cpp getlabel.cpp digitstring.cpp main.cpp marks.cpp memory.cpp  parts.cpp rbtree.cpp readconfig.cpp screenpart.cpp  trace.cpp keyproc.cpp marken.cpp procview.cpp menus.cpp inout.cpp move.cpp window.cpp edit.cpp file.cpp suspend.cpp select.cpp undo.cpp screen.cpp search.cpp onlykey.cpp editup.cpp myalloc.cpp cursesinit.cpp input.cpp contain.cpp withcontain.cpp filter.cpp  ascii.cpp  multidigit.cpp macros.cpp editmacros.cpp typelist.cc keyconfig.cpp keyinput.cpp repeat.cpp hassub.cpp savedatatype.cpp menufuncs.cpp  support.cpp bedrcproc.cpp desturbe.cpp gethelp.cpp disk.cpp memed.cpp re2search.cpp hyperscan.cpp gnusearch.cpp unitsearch.cpp bytesearch.cpp gnuasciiregex.cpp



CFILES=expandfilename.cpp glob.c 

ifeq ($(SYSTEM),FreeBSD)
CFILES+=prevention.c 
endif
PRESRC=$(CFILES) $(CPPFILES)
SRC=$(PRESRC) version.cpp
GENHEADERS= procedures.h copy.h help.h bedrcproc.h

#HANDHEADERS= builtinkeys.h  config.h convert.h cursesinit.h datatypes.h debug.h editor.h dialog.h getlabel.h glob.h head.h digitstring.h inout.h keyinput.h keylist.h main.h marks.h memory.h myalloc.h offtypes.h onlykey.h  rbtree.h readconfig.h screen.h screenpart.h system.h trace.h type.h views.h trace.cpp menu.h multidigit.h ascii.h  contain.h  filter.h  reverse.h macros.h keystrokes.h typelist.h visuals.h keyproc.h repeat.h hassub.h varmacro.h execproc.h desturbe.h shell.h termkeys.h viewbuf.h


HANDHEADERS= ascii.h biosdisk.h builtinkeys.h confdefines.h conf-.h config.h contain.h convert.h cursesinit.h dataprocer.h dataproc.h datatypes.h debug.h defines.h definesonly.h desturbe.h dialog.h digitstring.h editor.h execproc.h extrakeys.h filter.h getlabel.h glob.h hash.h hassub.h head.h helpdata.h help.h helpindex.h helptext.h inout.h keyinput.h keylist.h keyproc.h keystrokes.h macros.h main.h mainprocedures.h marks.h maxmenus.h memory.h menu.h misc.h mkmenus.h multidigit.h myalloc.h nepsem.h offtypes.h onlykey.h partypes.h pdcurses.h procedures.h ptypes.h rbtree.h readconfig.h regclass.h repeat.h reverse.h screen.h screenpart.h searchaim.h searchinterrupt.h selectsearch.h setenv.h shell.h system.h sys_types.h termkeys.h trace.h type.h typelist.h unsorted.h varmacro.h viewbuf.h views.h visuals.h win.h winpad.h



HEADERS= $(HANDHEADERS) $(GENHEADERS)
OTHERGEN= help
OTHERHAND= preprocedures head.h copy
OTHERFILES= $(OTHERHAND)  $(OTHERGEN)
OLDFILES= oldundo.cpp
SCRIPTS=mkdate.sh mkmachine.sh rules.mk
UPDATES=sourcenumber date.c md5sums.cpp
GENERATED= $(GENHEADERS) $(OTHERGEN)  md5file  md5file  mainprocedures.h extrakeys.h helpdata helpdata.h helpindex.h helptext.h chhelp unsorted.h 
PROGRAMS=extramenunr rxvtmenu  readhelp addmenu

ifeq ($(BUILDEXEEXT),)
EXEPROGRAMS= $(PROGRAMS)
else
ifeq ($(CYGWIN),)
EXEPROGRAMS= $(patsubst %,%$(BUILDEXEEXT),$(PROGRAMS)) 
else
EXEPROGRAMS= $(patsubst %,%$(BUILDEXEEXT),$(PROGRAMS)) winpaden$(BUILDEXEXT)
endif
endif

ifneq ($(origin USE_NEW),undefined)
OBJ := $(OBJ) myalloc.o
endif


ALLEXCEPTVERSION=$(SRC) $(HANDHEADERS) $(OTHERHAND) $(SCRIPTS)

ALLSOURCES=$(ALLEXCEPTVERSION) $(UPDATED)
ALLES= $(ALLSOURCES) $(CONFFILE) $(GENERATED)

all: mkinlinklist plugnum procedures.h $(PROGRAM)
	@echo done

.PHONY: plugnum 

plugnum:
	make -C ../plugins/examples/ srcnum
bash:
	bash
tags: $(CFILES) $(CPPFILES) Makefile
	ctags    $(CFILES) $(CPPFILES) $(HEADERS)
#	ctags  --sort  --c-types=cdefgmnstuvxAC $(CFILES) $(CPPFILES)



.PHONY: back
back: bak $(ALLES)
	cp $(ALLES) bak
bak:
	mkdir bak

$(INLINKLISTER):
	$(MAKE) -C ../plugins/examples makeinlinklist

#PROGCC=$(CXX)

.PHONY: src


src:
	@echo $(ALLES)

ifeq ($(CYGWIN),yes)
dep: winpad.h $(PRESRC) ../config Makefile extrakeys.h dataprocer.h dataproc.h procedures.h mainprocedures.h readhelp.cpp  
else
dep:  $(PRESRC) ../config Makefile extrakeys.h dataprocer.h dataproc.h procedures.h mainprocedures.h readhelp.cpp  
endif
	$(MAKE) -C ../plugins/examples makeinlinklist
	$(PROGCC) -MM -MG $(CPPFLAGS) $(CFILE) $(CPPFILES) readhelp.cpp > depend

winpad.h: 
	./winpaden > winpad.h
empty:
	@echo done
KEYCONFIG= ../utils/keyconfig

keyconfig:$(KEYCONFIG)

$(KEYCONFIG): bed	
	-rm $(KEYCONFIG)
	ln $(PROGRAM) $(KEYCONFIG)

#PROGCC=gcc

showconfig:
ifeq ($(BIOSDISK),y)
	@echo  "BIOSDISK " $(CYGWINDLL)
endif
ifeq ($(CONFIG_THREADS),y)
	@echo  "Background search "
endif
ifeq ($(CONFIG_PLUGIN),y)
	@echo  "Plugins "
else
	@echo  "No Plugins "
endif

$(PROGRAM):   $(OBJ)  version.o  $(OBJECTS)  
	$(PROGCC)   $(LDFLAGS) -o $(PROGRAM)  version.o $(OBJ) $(OBJECTS) $(LIBPATH) $(LIBS)

quick:  $(OBJ)  sourcenumber
	$(PROGCC) $(LDFLAGS) -o $(PROGRAM)  version.o $(OBJ)  $(OBJECTS) $(LIBPATH) $(LIBS)
#sourcenumber: $(SRC)  $(BIN2BYTE)
#	bash ./mkversion $(ALLEXCEPTVERSION)
#md5file: $(SRC)  $(BIN2BYTE)
#	bash ./mkversion $(ALLEXCEPTVERSION)

link:  dataprocer.h menufuncs.o procview.o menus.o  $(INLINKLIST) $(ININLINKLIB) 
	$(PROGCC) $(LDFLAGS) -o $(PROGRAM)  version.o $(OBJ)  $(OBJECTS) $(LIBPATH) $(LIBS)
linkonly:   
	$(PROGCC)  $(LDFLAGS) -o $(PROGRAM)  version.o $(OBJ)  $(OBJECTS) $(LIBPATH)  $(LIBS)

lines: 
	-rm screenpart.o editup.o editor.o
	$(MAKE) bed
$(BIN2BYTE):
	$(MAKE) -C ../utils bin2byte
unsorted.h: preprocedures  dataproc.h ../config
	 $(PROGCC) -DNOINLINK $(CFLAGS) -x c++   -E -P  $<  -o unsorted.h

mainprocedures.h: unsorted.h
	$(SORT) -b -t '(' -k 2 unsorted.h -o  $@

procedures.h: preprocedures  ../plugins/examples/inlink.h dataproc.h ../config
	 $(PROGCC) $(CFLAGS) -x c++   -E -P  $<  | $(SORT) -b -t '(' -k 2 > newprocedures.h
	(diff -q procedures.h newprocedures.h	&& echo no change &&rm newprocedures.h)||mv newprocedures.h procedures.h
	
help: usagehelp.in helpoldterm.c Makefile ../config cygwinhelp helptext
	cat usagehelp.in >  help
#	$(PROGCC)   $(CFLAGS) -x c++ -E -P usagehelp.in|sed -e s/\"//g > help
	echo '-f bedrc: Use configuration file bedrc, instead of env $(CONFVAR)' >>help
ifneq ($(CYGWIN),yes)
	echo '   or $(PERSCONFFILE) or $(GLOBALCONFFILE)' >>help
else
	echo -n '   or %APPDATA%\$(CONFFILE) or ' >>help
	cygpath -w $(GLOBALCONFFILE) >> help
endif
#	echo '-w: Always test filesize' >>help
ifeq ($(CONFIG_PLUGIN),y)
	echo	'-p plugin: load plugin at startup' >> help
endif
ifneq ($(WINPD),y)
	echo '-k file: Configure key bindings for current terminal. Append to file.' >> help
endif
ifeq ($(CONFIG_COLOR),y)
	echo '-B: black-white' >>help
	echo '-C: color' >>help
else
ifeq ($(CONFIG_COLOR),o)
	echo '-C: color' >>help
endif
endif
ifneq ($(filter -DNEWTERM,$(CFLAGS)),-DNEWTERM)
	$(PROGCC)   -imacros config.h $(CFLAGS) -E -P helpoldterm.c >> help
endif
ifeq ($(CYGWIN),yes)
	cat cygwinhelp >> help
endif
	cat helptext >> help

help.h:help $(BIN2BYTE)
	$(BIN2BYTE) help help help.h
	echo >> help.h
copy.h:copy $(BIN2BYTE)
	$(BIN2BYTE) copy copy copy.h
	echo >> copy.h
compileinfo:../config Makefile rules.mk
	echo -e  CFLAGS=$(CFLAGS)\\nLDFLAGS=$(LDFLAGS)\\nLIBS=$(LIBS)\\n > compileinfo
definesonly.h: confdefines.h $(HOSTCONF)
	cat $^|grep '^#define'  > definesonly.h
md5sums.cpp:  machine   compileinfo  definesonly.h $(BIN2BYTE)
#	cat machine compileinfo md5file> compinfo
	cat machine compileinfo definesonly.h > compinfo
	 $(BIN2BYTE) compinfo md5sums md5sums.cpp
	echo >> md5sums.cpp

#	 $(BIN2BYTE) md5file md5sums md5sums.cpp

#version.o:  version.cpp sourcenumber md5sums.cpp help.h copy.h

#	$(PROGCC) $(CFLAGS) -c version.cpp



#menus.o: menus.cpp
#	g++  -O2   $(OLDCFLAGS)  -c -o menus.o menus.cpp

debug:
	-rm main.o trace.o debug.o editor.o myalloc.o
	$(MAKE)
mmap:
	-rm memory.o
	$(MAKE)
clean: 
	-rm    $(OBJ) version.o core  debug.o trace.o myalloc.o inlink.a  depend.bak $(CLEANOBJECTS)   $(BUILDOBJ)
	-rm $(EXEPROGRAMS) $(PROGRAM)$(HOSTEXEEXT)
	
#	-rm rxvtmenu $(PROGRAM) core  inlink.a *.o*
realclean: clean
	-rm regex.o
	-rm $(GENERATED) 
	-rm md5sums.cpp #tags 
	-rm depend

machine: sourcenumber
	./mkmachine.sh

date.c:  sourcenumber
	./mkdate.sh
version.o: version.cpp sourcenumber md5sums.cpp copy.h help.h  date.c  ../config config.h
	$(PROGCC) $(CFLAGS) -c $<

digitstring: digitstring.cpp
	$(CXX) -g digitstring.cpp -DTEST -o digitstring 
getfree: getfree.cpp
	$(CXX) $(CFLAGS) getfree.cpp -DTEST -o getfree 


#%.o:%.i

#	$(PROGCC)  $(CXXFLAGS) $< -o $@
%.i:%.cpp
	$(PROGCC) -E -P $(CXXFLAGS) $< -o $@
#	$(GCC) -E  $(CPPFLAGS) $< -o $@
%.s:%.cpp
	$(PROGCC) -S  $(CXXFLAGS) $< -o $@
%.i:%.c
	$(PROGCC) -E -P $(CFLAGS) $< -o $@


stupid: inlink.h
	touch stupid
.PHONY: mkinlinklist plugs  mkinlink_h

mkinlink_h:
	$(MAKE) -C ../plugins/examples/ mkinlink_h
mkinlinklist:
	$(MAKE) -C ../plugins/examples/ $(INLINKLIST)
#	$(MAKE) -C ../plugins/examples/ $(@F)
	
#plugs:
#	for plug in $(ININLINKLIB); do \
#	$(MAKE) -C ../plugins/examples/ $(@F); \
#	done

plugs:	$(ININLINKLIB)
../plugins/examples/%: 
	$(MAKE) -C ../plugins/examples/ $(@F)
../plugins/examples/inlink.h: 
	$(MAKE) -C ../plugins/examples/ inlink.h

$(ININLINKLIB):
	$(MAKE) -C ../plugins/examples/ $(@F)

grep.%:
	grep $* *.c* *.h

include dataproc.mk


getch:getch.c 
	$(GCC) -g $(CFLAGS) -UHAS_BOOL getch.c -o getch $(LIBS)
getcher:getcher.c 
	$(GCC) -g $(CFLAGS) -UHAS_BOOL getcher.c -o getcher $(LIBS)


#memory.o:memory.i
#	$(GCC) -c $(CFLAGS) -x c++ memory.i


support: support.cpp expandfilename.cpp
	$(CC) -g -DTEST $^ -o support

#TOBUILDCFLAGS:=$(CFLAGS)
keyproc.o: builtinkeys.h
keyproc.o: extrakeys.h
readconfig.o:bedrcproc.h
bedrcproc.h: bedrcproc.cpp
	echo '/*WARNING automatically generated  from bedrcproc.cpp */' > bedrcproc.h
	grep '^initword' bedrcproc.cpp|sed -e 's/^initword\([^{]*\).*/initword\1/'|$(SORT) -b -t '(' -k 2 >> bedrcproc.h

extramenunr$(BUILDEXEEXT):menus.cpp editor.h menu.h
	$(TOBUILDCXX) -DPRINTMAXSHOWMENUS=1 $(TOBUILDCFLAGS) extramenunr.cpp -o extramenunr
extramenunr.i:menus.cpp editor.h menu.h

=== utils/Makefile ===
include ../config
export LC_ALL=C
CFLAGS+=-O3 -s 
#PROGRAMS=getch mkkeydef  bin2byte
PROGRAMS=bin2byte 
EXEPROGRAMS= $(patsubst %,%$(EXEEXT),$(PROGRAMS))
EXEBYTEC= $(patsubst %,%$(EXEEXT),bin2bytec)

UTILSDIR=$(CONFDIR)/utils
LIBS= $(USENCURSESLIB)
LOADLIBES= $(USENCURSESLIB)

ifneq ($(CROSS_COMPILING),yes)
ifeq ($(TOBUILDCFLAGS),)
	TOBUILDCFLAGS:=$(CFLAGS) -DONE
	TOBUILDLDFLAGS:=$(LDFLAGS) -DONE
endif
endif

ifeq ($(CROSS_COMPILING),yes)
all: $(PROGRAMS) bin2bytec
else
all: $(PROGRAMS)
endif
SRC :=  bin2byte.c features.h

bin2byte: bin2byte.c
	$(TOBUILDCC)  $(TOBUILDCFLAGS) $(TOBUILDLDFLAGS) $< -o $@ 
bin2bytec: bin2byte.c
	$(CC)  $(CFLAGS) $< -o $@ 
mkkeydef: mkkeydef.c
	$(TOBUILDCC)  $(TOBUILDCFLAGS) $< -o $@ $(LIBS)
#keyconfig: keyconfig.c
#	$(TOHOSTCXX) $(CFLAGS) $< -o $@ $(LIBS)
getch.o: getch.c
	$(TOBUILDCXX) -c -DHAS_BOOL -D_GNU_SOURCE -DCURSES $(CFLAGS) $< -o $@
%.i:%.c;
	$(TOBUILDCC) $(TOBUiLDCFLAGS) -E $< -o $@ 
realclean: clean
clean:
	-rm	$(EXEPROGRAMS) core $(EXEBYTEC)

install: $(PROGRAMS)
	-mkdir -p $(ROOTDIR)$(UTILSDIR)
	cp $(SRC) $(ROOTDIR)$(UTILSDIR)
ifeq ($(CROSS_COMPILING),yes)
ifneq ($(CYGWIN),yes)
	cp  bin2bytec $(ROOTDIR)$(UTILSDIR)/bin2byte
else
	cp  bin2bytec.exe $(ROOTDIR)$(UTILSDIR)/bin2byte.exe
endif
else
ifneq ($(CYGWIN),yes)
	cp  $(PROGRAMS) $(ROOTDIR)$(UTILSDIR)
else
	cp  bin2byte.exe $(ROOTDIR)$(UTILSDIR)
endif
endif

=== x11/Makefile ===
export LC_ALL=C
include ../config
ifeq ($(CONFIG_XBED),y)
$(XPROGRAM)one: ../src/rxvtmenu startbed afterrxvt endbed middlebed ../config Makefile
	cat startbed > $@
	echo -n $(RXVT) >> $@
	cat afterrxvt >> $@
	echo  exec $(BINDIR)/$(PROGRAM) '$$*'>>$@
	cat middlebed >> $@
	../src/rxvtmenu >> $@
	cat terminal >> $@
	cat endbed >> $@
	chmod a+x $@

$(XPROGRAM): bedtryhead middlebed endbed ../src/rxvtmenu  ../config Makefile
	echo '#!/bin/sh ' > $@
	echo RXVTS=\"$(RXVT) $(NRXVT)\" >>$@
	cat bedtryhead >> $@
	echo USERXVT=yes exec  $(BINDIR)/$(PROGRAM) '$$*' >>$@
	echo 'fi' >> $@
	cat middlebed >> $@
	../src/rxvtmenu >> $@
	cat terminal >> $@
	cat endbed >> $@
	chmod a+x $@

../src/rxvtmenu:../src/rxvtmenu.c
	$(MAKE) -C ../src rxvtmenu

install:
	-mkdir -p $(ROOTDIR)$(BINDIR)
	cp $(XPROGRAM)  $(ROOTDIR)$(BINDIR)/$(XPROGRAM)
else
install:
	echo rxvt with menu support needed for  $(ROOTDIR)$(XPROGRAM)
endif

clean:
	-rm xbed

realclean: clean

=== plugins/examples/Makefile ===
export LC_ALL=C
ifeq ($(HOME),)
	export HOME=/
endif

export SRCPLUGINDIR=..
CONFIGFILE= ../../config

ifeq ($CONFDIR),)
	export PLUGINDIR=..
else
	export PLUGINDIR=$(CONFDIR)/plugins
endif
include $(CONFIGFILE)
#include  ../rules.mk


DEFINES_H=../defines.h
ifeq ($(CONFIG_STATIC),y)
CFLAGS := $(CFLAGS) -DSTATIC=1
endif
ifeq ($(CONFIG_LARGEFILES),y)
CFLAGS := $(CFLAGS) -DLARGEFILES=1
endif
ifeq ($(CONFIG_THREADS),y)
CFLAGS := $(CFLAGS) -DUSETHREADS=1  -D_REENTRANT=1
endif

EXAMPLEDIR=$(PLUGINDIR)/examples
EXAMPLEDIRSTR=\"$(EXAMPLEDIR)\"
GENERAL=$(SRCPLUGINDIR)/plugin.cpp
HEADERS=$(SRCPLUGINDIR)/faked.h  $(SRCPLUGINDIR)/mainprocedures.h

LDRELOC=-Ur -d
TOHOSTCXX=$(CXX) 
TOHOSTCC=$(CC) 

#CFLAGS:= -fno-builtin-memcpy -fPIC $(CFLAGS)
CFLAGS:= -fPIC $(CFLAGS)
BIN2BYTE= ../../utils/bin2byte
PLUGINCFLAGSALL=-DPLUGINSRC=1

ifeq ($(CONFIG_DEBUG),n)
PLUGINLDFLAGS= -O3 -s  $(LDFLAGS)
PLUGINCFLAGS= $(CFLAGS) $(OPTS) -O3 $(PLUGINCFLAGSALL)
else
ifeq ($(CONFIG_DEBUG),o)
PLUGINLDFLAGS= -O2 -g $(LDFLAGS)

PLUGINCFLAGS= $(CFLAGS) $(OPTS) -g -O2 $(PLUGINCFLAGSALL) -DDEBUGFLAG


else
PLUGINCFLAGS= $(CFLAGS) $(OPTS) -g $(PLUGINCFLAGSALL) -DDEBUGFLAG

PLUGINLDFLAGS= -g $(LDFLAGS)


endif
endif
#BEDSRCDIR=\"../../src\"
PLUGINREST := -I../ -I../../src/ -I../../src/empty  $(X_CFLAGS)   -DNEWTERM     -DBEDSRCDIR=$(BEDSRCDIR)
PLUGINCFLAGS := $(PLUGINREST) $(PLUGINCFLAGS) # -m96bit-long-double

CFLAGSNOOPT= $(CFLAGS) $(PLUGINCFLAGSALL) $(PLUGINREST)
#PLUGINCFLAGS=-g
#PLUGINLDFLAGS=-s -O6
#PLUGINLDFLAGS= -O6
#PLUGINLDFLAGS= -g
#PLUGINLDFLAGS+=-Wl,-z,noexecstack
#PLUGINLDFLAGS+=-Wl  -z --noexecstack 

ifneq ($(SYSTEM),SunOS)
#PLUGINLDFLAGS+= -z --noexecstack 
PLUGINLDFLAGS+=-Wl,-z,noexecstack $(LDFLAGS)
endif



SRC:=   bitcontains.cc bitcpy.cc bitfields.cc bitfields.h bitflags.cc char2.cc chars.c crc.c  duplicate.cpp   edit.cc  file.cpp filter.cpp float.cc disass.cc hash.h disass-use.c nextitem.cpp subtract.cc  signed.cc skip.cpp time.cpp  translate.cc undoall.cpp unsigned.cpp  backward.cc oldsigned.cc  oldsigned.h signed.h  title.cc helpf1.cc searchclip.cc newdata.cc install.cc datatypeinfo.cc cut.cc eventnames.h
TESTSRC:= testall.cpp testbed.cpp testmode.cpp testsave.cpp testsearch.cpp  

DATATYPES:=  char2.plug float.plug subtract.plug signed.plug  unsigned.plug ebcdic2ascii.plug bitcontains.plug bitflags.plug  oldsigned.plug newdata.plug
MISC:= file.plug filter.plug disass-use disass.plug nextitem.plug undoall.plug  skip.plug duplicate.plug edit.plug  translate.plug backward.plug title.plug  helpf1.plug install.plug searchclip.plug datatypeinfo.plug cut.plug

ifeq ($(HAS_X),y)
MISC+= switchsize.plug putselect.plug rxvt.plug
endif
ifeq ($(USES_ELF),y)
DATATYPES+= index2table.plug elftables32.plug
SRC+=index2table.cc elftables32.cc index2table.h
endif


TESTPLUG=  testall.plug testbed.plug testmode.plug testsave.plug testsearch.plug
PLUGINS= $(DATATYPES)  $(MISC)
GIVEOLD= time.plug  ebcdic2ascii.plug skip.plug file.plug  duplicate.plug nextitem.plug 
GIVENEW= float.plug signed.plug  edit.plug  bitflags.plug bitcontains.plug translate.plug  backward.plug title.plug helpf1.plug searchclip.plug datatypeinfo.plug cut.plug filter.plug  disass.plug  undoall.plug 
ifeq ($(USES_ELF),y)
GIVEMISC=disass-use 
endif
ifeq ($(ELFSIZE),32)
GIVENEW+=index2table.plug elftables32.plug
endif
ifeq ($(HAS_X),y)
SRC+= switchsize.cc rxvt.cc
GIVENEW+= switchsize.plug rxvt.plug
	ifeq ($(CONFIG_THREADS),y)
	SRC+= putselect.cc
	GIVENEW+=putselect.plug 
	endif
endif

ifeq ($(CYGWIN),yes)
SRC+=clipboard.cc switchsize.cc rxvt.cc

endif

PREGIVE= $(GIVEOLD) $(GIVENEW)
ifeq ($(CONFIG_PLUGIN),y)
GIVE= $(filter-out $(LINKIN) $(LINKINDYN),$(PREGIVE))
else
GIVE=
endif
#GIVE= $(filter signed.plug,$(PREGIVE))
NOTGIVE= $(filter-out $(PREGIVE),$(PLUGINS))
NONEX= $(filter-out $(PLUGINS),$(GIVE))
INLINK=$(LINKIN:%.plug=%.oo)
INLINKSRC=$(filter $(wildcard *.cc *.cpp *.CPP *.CC), $(wildcard $(LINKIN:%.plug=%.c[cp]*)) )
INLINKDYN=$(LINKINDYN:%.plug=%.ooo)
INLINKDYNSRC=$(filter $(wildcard *.cc *.cpp), $(wildcard $(LINKINDYN:%.plug=%.c[cp]*)) )

#INLINKSRC=$(patsubst %.plug,%.cc %.cpp,$(LINKIN))
EXAMPLES=  $(filter-out $(LINKIN) $(LINKINDYN),$(PLUGINS))
INSTALL=install
GENERATED= ascii2ebcdic.h ebcdic2ascii.h ebcdic2ascii.cc floatdef.h

ALLSRC:=Makefile $(SRC) $(GENERATED) encodechar.sh macro2plug.sh

ALLFILES :=$(ALLSRC) $(PLUGINS)
GIVEALL:=$(ALLSRC) $(GIVE)
INLINKALL= $(patsubst bitcontains.%,bitcontains.% bitcpy.o bitfields.o, $(INLINK) $(INLINKDYN) )
ifeq ($(SYSTEM),FreeBSDnot)
all:  nss_dns.so.1 $(EXAMPLES)
else
all:   $(EXAMPLES)
endif
give:  $(GIVE)  $(GIVEMISC)
data:$(DATATYPES)
INBEDRC=$(filter-out switchsize.plug rxvt.plug putselect.plug,$(GIVE))
try:
	@echo examples not GIVES $(NONEX)
	@echo GIVE no examples  $(NOTGIVE)
	@echo EXAMPLES: $(EXAMPLES)
	@echo GIVENEW: $(GIVENEW)	
	@echo give: $(GIVE)	
	@echo linkin: $(LINKIN)
	@echo LINKIN: $(INLINK)
	@echo LINKINDYN: $(INLINKDYN)
	@echo INLINKSRC: $(INLINKSRC)
	@echo INLINKSRC: $(INLINKDYNSRC)
ingive: Makefile
	@printf " $(INBEDRC:%.plug=plugin %.plug\n)" > ingive
	@printf "\nkeys 27 91 49 49 126 = f1\nkeys 27 91 91 65 = f1\n" >> ingive

#	sed --silent -e "{s/^[ 	]*call([ 	]*\([^),; 	.*/\\]*\)[ 	]*)/prodef(\1)/p; s/^[ 	]*callname([ 	]*\([^),; 	.*/\\]*\)[ 	]*)/prodefname(\1)/p; }" $(INLINKSRC) >  $@

../../src/inlink.a: $(INLINKALL) 
	-rm $@
	ar rsc $@ $(INLINKALL)   

../../src/inlink.o: $(INLINKALL) $(CONFIGFILE)
	ld -o $@ $(INLINKALL)   $(LDRELOC)
#grep 'will_be_mentioned_in_procedures_h_.*_var_to_export_it'|
LINKINCCCPP= $(patsubst %.cc,%.ii, $(filter %.cc,$(INLINKSRC)  ))
LINKINCPPCPP= $(patsubst %.cpp,%.ii, $(filter %.cpp,$(INLINKSRC)  ))


ifneq ($(LINKINCCCPP),)
LINKINCPP += $(LINKINCCCPP)
endif
ifneq ($(LINKINCPPCPP),)
LINKINCPP += $(LINKINCPPCPP)
endif


#	grep 'int (Editor::\*will_be_mentioned_in_procedures_h_\([^)]*\)_var_to_export_it)(void)=\&Editor::' $(LINKINCPP)> uitfile

# int (Editor::*for_procedure_h_##proc##_prodefname)(void)=&Editor::proc;char name_part_##proc##_end[]=name;

#	grep -h 'for_procedures_h_\([^)]*\)_prodef' $(LINKINCPP)
tmpmainprocedures.h:
	cp ../../src/procedures.h
inlinker:
	@echo $(LINKINCPPCPP)
	@echo $(LINKINCCCPP)
	@echo .$(LINKINCPP).
inlink.h: $(LINKINCPP)  $(CONFIGFILE) 
ifdef LINKINCPP
	grep -h 'int (Editor::\*for_procedures_h_\([^)]*\)_prodef.*)(void)=\&Editor::\([^;]*\);' $(LINKINCPP) |sed '{s/int (Editor::\*for_procedures_h_\([^)]*\)_prodef)(void)=\&Editor::\([^;]*\);/prodef(\1)/g;s/int (Editor::\*for_procedures_h_\([^)]*\)_prodefname)(void)=\&Editor::\([^;]*\);char name_part_\([^)]*\)_end\[\]=\([^;]*\);/prodefname(\1,\4)/g;}'  > inlink.h
else
	-rm inlink.h
	touch inlink.h
endif


##define callname(name,proc)  int (Editor::*for_procedures_h_##proc##_prodefname)(void)=&Editor::proc;char name_part_##proc##_end[]=name;
#../../src/inlink.h: $(INLINKIN)  $(CONFIGFILE) 
#	sed  '{s/^[ 	]*call([ 	]*\([^),; 	.*/\\]*\)[ 	]*)/prodef(\1)/p; s/^[ 	]*callname([ 	]*\([^),; 	.*/\\]*\)[ 	]*)/prodefname(\1)/p; s/^.*//p; }' $(INLINKSRC) >  $@
#	$(TOHOSTCXX) $(PLUGINCFLAGS) -DPLUGIN -x c   -E -P -D"call(x)=uniekvoorinlinkhprodef(x)" -D"callname(name,x)=uniekvoorinlinkhprodefname(name,x)"   $(INLINKSRC)> tussengegs

bitfields.plug: bitfields.o bitcpy.o
	echo hello
	$(TOHOSTCXX) $(PLUGINLDFLAGS) -shared  $^ -o $@ 
	chmod a-x $@
#s/-DEXAMPLEDIR=$(EXAMPLEDIR)/\-DEXAMPLEDIR\=\$(EXAMPLEDIRSTR)/g

bitfields.o: bitfields.cc
	$(TOHOSTCXX) -DNOEDITOR -DGLOBAL -DUNDER $(PLUGINCFLAGS) -DPLUGIN -DEXAMPLEDIR=$(EXAMPLEDIRSTR) -DSOURCEFILENAME=\"examples/$<\" -c $< -o $@

bitcontains.plug: bitcontains.o bitcpy.o bitfields.o
	$(TOHOSTCXX) $(PLUGINLDFLAGS) -shared  $^ -o $@ 
	chmod a-x $@
mkfloatdef: mkfloatdef.cc Makefile
	$(TOBUILDCXX) -DGLOBAL -DUNDER $(PLUGINCFLAGS) -DPLUGIN  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\"  $< -o $@

floatdef.h: mkfloatdef
	./mkfloatdef > floatdef.h
#float.oo: floatdef.h
#float.ooo: floatdef.h
#float.o: floatdef.h

%.plug: %.o
#	$(TOHOSTCXX) -shared $(PLUGINLDFLAGS) $< func.o -o $@
	$(TOHOSTCXX) -shared $(PLUGINLDFLAGS) $< -o $@
	chmod a-x $@
	rm $<

%.o: %.cpp  $(GENERAL) $(HEADERS)  
	$(TOHOSTCXX) $(PLUGINCFLAGS) -DPLUGIN=1 -DEXAMPLEDIR=$(EXAMPLEDIRSTR) -DSOURCEFILENAME=\"examples/$<\" -c $(GENERAL) -o $@

%.o: %.cc $(HEADERS)  
	$(TOHOSTCXX) -DGLOBAL -DUNDER $(PLUGINCFLAGS) -DPLUGIN  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\" -c $< -o $@


elftables32.o: elftables32.cc  $(HEADERS)  
	$(TOHOSTCXX) -g  -DGLOBAL -DUNDER $(CFLAGSNOOPT) -DPLUGIN  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\" -c $< -o $@

ifneq ($(CYGWIN),yes)
XINCL=$(X_CFLAGS)
endif
switchsize.o: switchsize.cc $(HEADERS) 
	$(TOHOSTCXX) $(XINCL) -DGLOBAL -DUNDER $(PLUGINCFLAGS) -DPLUGIN  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\" -c $< -o $@
%.i: %.cc $(HEADERS) 
	$(TOHOSTCXX)  -DGLOBAL -DUNDER -DPLUGIN $(PLUGINCFLAGS)  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\" -E -P $< -o $@

%.oo: %.cc  $(HEADERS)  
	$(TOHOSTCXX)  -DGLOBAL -DUNDER $(PLUGINCFLAGS)  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\" -c $< -o $@

#bitcontains.oo: bitcontains.oo bitcpy.oo bitfields.oo
#	ld -o $@ $^   $(LDRELOC)

#bitcontains.ooo: bitcontains.ooo bitcpy.ooo bitfields.ooo
#	ld -o $@ $^ $(LDRELOC)


%.ooo: %.cc  $(HEADERS)  
	$(TOHOSTCXX) -DFAKE_DYNAMIC=1  -DGLOBAL -DUNDER $(PLUGINCFLAGS)  -DEXAMPLEDIR=$(EXAMPLEDIRSTR) -DSOURCEFILENAME=\"examples/$<\" -c $< -o $@
elftables32.ooo: elftables32.cc  $(HEADERS)  
	$(TOHOSTCXX) -DFAKE_DYNAMIC=1  -DGLOBAL -DUNDER $(CFLAGSNOOPT)  -DEXAMPLEDIR=$(EXAMPLEDIRSTR) -DSOURCEFILENAME=\"examples/$<\" -c $< -o $@

%.ooo: %.cpp  $(GENERAL) $(HEADERS) 
	$(TOHOSTCXX) -DFAKE_DYNAMIC $(PLUGINCFLAGS)  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\" -c $(GENERAL) -o $@
%.oo: %.cpp  $(GENERAL) $(HEADERS) 
	$(TOHOSTCXX) $(PLUGINCFLAGS)  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\" -c $(GENERAL) -o $@

%.iii: %.cc  $(HEADERS)  $(CONFIGFILE)
	$(TOHOSTCXX) -P  -DFAKE_DYNAMIC  -DGLOBAL -DUNDER $(PLUGINCFLAGS)  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\" -E $< -o $@
%.iii: %.cpp  $(GENERAL) $(HEADERS) 
	echo hallo
	$(TOHOSTCXX) -P -DFAKE_DYNAMIC $(PLUGINCFLAGS)  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\" -E $(GENERAL) -o $@
	$(TOHOSTCXX) -DFAKE_DYNAMIC $(PLUGINCFLAGS)  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\" -c $(GENERAL) -o $*.ooo


%.ii: %.cc  $(HEADERS)  $(CONFIGFILE)
	$(TOHOSTCXX)  -DGLOBAL -DUNDER $(PLUGINCFLAGS)  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\" -E $< -o $@
#	$(TOHOSTCXX) '-Dwill_be_used_to_get_prodefname_in_inlink_h(x,y)=prodefname(x,y)' '-Uwill_be_used_to_get_prodef_in_inlink_h(x)=prodef(x)' -DGLOBAL -DUNDER $(PLUGINCFLAGS)  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\" -E $< -o $@
#	$(TOHOSTCXX) '-Uwill_be_used_to_get_prodefname_in_inlink_h' '-Uwill_be_used_to_get_prodef_in_inlink_h' -DGLOBAL -DUNDER $(PLUGINCFLAGS)  -DEXAMPLEDIR=$(EXAMPLEDIRSTR) -DSOURCEFILENAME=\"examples/$<\" -E $< -o $@

%.ii: %.cpp  $(GENERAL) $(HEADERS) 
	$(TOHOSTCXX)  -P $(PLUGINCFLAGS)  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\" -E $(GENERAL) -o $@
%.s: %.cpp  $(GENERAL) $(HEADERS) 
	$(TOHOSTCXX)  $(PLUGINCFLAGS) -DPLUGIN  -DEXAMPLEDIR=$(EXAMPLEDIRSTR)  -DSOURCEFILENAME=\"examples/$<\" -S $(GENERAL) -o $@

disass-use: disass-use.c 
	$(TOHOSTCC) $(CFLAGSNOOPT)  -g disass-use.c -o disass-use
#	cd $(EXAMPLEDIR) ;pwd>;cd $(CURRENT)

nss_dns.so.1:./mknss_dns.sh  Makefile ../../config
	sh ./mknss_dns.sh .
install: $(CONFIGFILE)
	-mkdir -p $(ROOTDIR)$(EXAMPLEDIR)
ifeq ($(SYSTEM),FreeBSD)
	sh ./mknss_dns.sh $(ROOTDIR)$(EXAMPLEDIR)
endif
	cp  $(GIVEMISC) $(GIVEALL) $(ROOTDIR)$(EXAMPLEDIR)
	(CURDIR=`pwd`;cd $(ROOTDIR)$(EXAMPLEDIR);chmod 644 $(GIVEALL); cd $$CURDIR)

#	-rm $(EXAMPLEDIR)/disass-use
#	$(MAKE) -C  $(EXAMPLEDIR) disass-use
#	-rm $(EXAMPLEDIR)/disass.plug 
#	$(MAKE) -C  $(EXAMPLEDIR) disass.plug

=== debian/changelog ===
bed (3.0.0) stable; urgency=high

  * Faster version of showmarks 
  * Uniformalized search procedures
  * changed plugin searchclip so that is doesn't take over all search options.
  * MS windows: bedrc now in %APPDATA%
  * replace old regex-0.12 with NETBSDs external/gpl3/binutils/dist/libiberty/regex.c and external/gpl3/binutils/dist/include/xregex*.h
  * changed copyselect so recent changes are memorized
  * added unit search and replace
  * doesn't search icase in non ascii, non regex anymore
  * added Keep options to search to save search options
  * Changed regex syntax: regex interpretation now without \: 0{10} now means 0000000000
  * MSWindows: ReadFile and WriteFile in PhysicalDrive[0-9]+ need only work with RAM addresses 
  *   starting at sector boundaries. And one of my hardrives only worked with even addresses, so I 
  *   rearanged everything to comply.
  * color shows search hits
  * libre2 and hyperscan regex
  * nextsearch starts now from cursor position
  * removed MAXUNDO limit
  * sometimes no key input, because of rejecting of * giving negativ intptr_t. Repaired.
  * Alt-f,n (emptyfile) no longer connected to .neededbybed, size can vary
  * use libmagic for instead of file for filetype
  * ANDROID search for temporary file locations
  * compiles with Androids NDK bionic g++ libc
  * float.cc works with sizeof(long double)=8 
  * cross-compiling using ./configure --host=host-type now possible

 -- Jaap Korthals Altes <bed.dse.nl>  Wed, 17 Jan 2018 16:46:17 +0100

bed (2.27.2) unstable; urgency=medium

  * end thread without using pthread_cancel(threadsearch), because of problems in win64: closing file during background search end
  * interrupting background search.
  * added  LOGMESSAGE
  * added some read error reporting Editor::fromfile(OFFTYPE pos)
  * Removed some serious errors in Windows NT+ version: 
  * 	-FSCTL_ALLOW_EXTENDED_DASD_IO was not always set after reopening disk.
  * minor changes to make it compile unter cygwin64
  * inconsequental removal of some warning messages
  * change of = to == somewhere

 -- Jaap Korthals Altes <bed.dse.nl>  Wed, 13 Sep 2017 17:17:47 +0200

bed (0.2.27) unstable; urgency=medium

  * Removed some size restrictions, can now open linux's /dev/full
  * configASCII byt=maxres
  * getfree now gives a better estimate of free memory
  * made it compile under  64 bits Linux and FreeBSD and 32 bits OpenSolaris x86
  * removed compiler warning, by changing char in unsigned and signed char, changed to const, cast unsigned to int
  * 	etc
  * closes disk handle in disk.cpp
  * set off desturbe.h/.cpp 's locks with USETHREADS. It has only to do with interrupt and isn't mentioned in the background thread, 
  *   so why add it when using multiple threads? And for interrupt to normal course should never wait, interrupt should only succeed when
  * 	it is save to do so.
  * set background searching in win32 version
  * merged some searched functions in memory.cpp and added interrupt posibility under 
  *   cygwin while searching harddisk
  * Switched to windows versions for file attributes (getfiles, filegeg, filedata) en chdir
  * used fullname because cygwin didn't use windows current directory (or so)

 -- Jaap Korthals Altes <bed.dse.nl>  Mon, 26 Jul 2010 11:06:52 +0200

bed (0.2.26) unstable; urgency=medium

  * minor changes in manual en mvtakefile getfile.cc
  * Document->Untitled

 -- Jaap Korthals Altes <bed.dse.nl>  Thu, 13 Aug 2009 10:43:06 +0200

bed (0.2.25) unstable; urgency=medium

  * in getvolumegegs always remove '\' again
  * added Editor::consoleresize
  * ncurses version in windows console sets screenbuffer equal to window size
  * bedrc: TERM=rxvt if COLORTERM=gnome-terminal
  * getotherterm only once when called within 2 seconds
  * %LOCALAPPDATA%
  * makes switchsize.plug switch to smaller above a certain percentage of maximum

 -- Jaap Korthals Altes <bed.dse.nl>  Mon, 05 Jan 2009 15:51:56 +0100

bed (0.2.24) unstable; urgency=medium

  * configure aangepast voor nieuwe pdcurses
  * windows: disk aanduidingen, filedata nu werkend in windows xp/vista
  * removed some code mvtakefile(int ypos,int xpos,const char *com,const char *pat) (file getfile.cpp) which resulted in a endless loop and didn't seem to have a function.
  * made it compile under gcc version 4.3.0 20080428 (Red Hat 4.3.0-8) (GCC) (changed classname:: within class classname, changed x= new (type *)[nr] etc)

 -- Jaap Korthals Altes <bed.dse.nl>  Mon, 22 Dec 2008 22:08:52 +0100

bed (0.2.23) unstable; urgency=medium

  * Added a few changed in memory.cpp, getfile.cpp and disk.cpp to 
  * 	improve raw disk acces under Windows XP: ]
  * 		- determining the size of \\.\PHYSICALDRIVE[0-20]
  * 		- opening raw disk via Alt-f,o
  * 		- faster detection of devices
  * Use new WINDIR (Makefile, config.in) variable
  * Modifies makes now a difference between detecting a different and the
  * 	 occurrance of an error (file.cpp).

 -- Jaap Korthals Altes <bed.dse.nl>  Wed, 07 Jul 2004 11:24:30 +0200

bed (0.2.22) unstable; urgency=medium

  * Removed atexit from HANDLE initcursorinfo(void) 
  * Shell in subprogram possible under FreeBSD
  * use real suspend again under Linux 
  * use PAGER if helptext> LINES_USE_PAGER
  * disass paths and install corrected

 -- Jaap Korthals Altes <bed.dse.nl>  Fri, 05 Mar 2004 20:27:02 +0100

bed (0.2.21) unstable; urgency=medium

  * a few unimportant files wrong in uninstall list and archive

 -- Jaap Korthals Altes <bed.dse.nl>  Wed, 28 Jan 2004 12:35:31 +0100

bed (0.2.20) unstable; urgency=medium

  * putselect.plug made debugfile /tmp/putselect.txt. changed
  * changed plugins/examples/Makefile a little bit to precompile a few more plugins
  * changed at some places in src/Makefile GCC in GXX
  * Removed struct cast out of src/keyconfig.cpp
  * varmacro.h condition changed
  * change help menus a little bit

 -- Jaap Korthals Altes <bed.dse.nl>  Tue, 27 Jan 2004 17:24:41 +0100

bed (0.2.19) unstable; urgency=medium



=== debian/control ===
Source: bed
Section: utils
Priority: optional
Maintainer: Jaap Korthals Altes <bed@dse.nl>
Standards-Version: 3.0.0

Package: bed
Architecture: any
Depends: ${shlibs:Depends}
Description: Adjustable data format binary editor
 Adjustable data format binary editor. Data formats are
 ASCII, unsigned and signed integers, float, bit-flags,
 bit-fields, labels, ebcdic and time_t. Different sizes
 and byte orderings are possible. Data types can
 be used in structures. Other data formats, filters and
 procedures can be defined in plugins. Contains copy,
 past, undo, redo, search, replace, marks, record/play and
 context sensitive help. Raw edit of hard drives. Under  
 Linux and FreeBSD even usable without X windows.

=== debian/rules ===
#!/usr/bin/make -f

package=bed


build: buildonce

buildonce:
	dh_testdir
	./configure --prefix=/usr
#	$(MAKE) linuxconfig
	$(MAKE) dep
	$(MAKE)
	touch buildonce

clean:
	dh_testdir
	dh_clean
	-rm -f buildonce
	$(MAKE) realclean
	-rm -rf debian/bed debian/*~ debian/files* debian/substvars

install: buildonce
	dh_clean
	dh_installdirs
	$(MAKE) installfiles ROOTDIR=`pwd`/debian/tmp/

binary-arch:  install
	 $(MAKE) control
	 install -d debian/bed/DEBIAN/	
	 install -d debian/tmp/DEBIAN/	
	 dpkg-shlibdeps debian/tmp/usr/bin/bed
	 dpkg-gencontrol 
#	 dpkg-gencontrol -isp
	 install -m 755  debian/preinst   debian/bed/DEBIAN
	 install -m 755  debian/postinst   debian/bed/DEBIAN
	 install -m 755  debian/postrm   debian/bed/DEBIAN
	 install -m 755  debian/preinst   debian/tmp/DEBIAN
	 install -m 755  debian/postinst   debian/tmp/DEBIAN
	 install -m 755  debian/postrm   debian/tmp/DEBIAN
	 dpkg-deb -Zxz  -b debian/tmp  ..
#	 dpkg --build -Zxz debian/tmp  ..
#	 dh_builddeb -Zxz 
	 

binary-indep:

binary: binary-arch

.PHONY: binary binary-arch binary-indep clean install build
